#!/usr/bin/perl -w
#
#This script reads a directory and bzips the files in that directory.
#it Accumulates the data and when the data exceeds 700mb it uses
#mkisofs to create an image that can be burned to cd with cdrecord.
#
#ex: $cdrecord -v speed=? dev=?,?,? cd_image0.raw
# 
#
# This subroutine creates the image with mkisofs
#
#
my $dir;
sub mk_image {
      my @zipped_name = @_;
      #create directory to mkisofs 
      $my_dir = "$dir/tmp06458a";
      if ( !(chdir $my_dir)) {
        mkdir $my_dir;
        chdir $my_dir;
      } 

      foreach $name_z (@zipped_name) {
        print "linking $name_z \n";
        link "../$name_z", $name_z; 
      }
      
      $image_name = "../cdimage_$num.raw"; 
      $num++;
      print "createing volume label: \n";
      $_ = $zipped_name[0];
      tr/[a-zA-Z][\.]//d; 
      $first_name = $_;

      $_ = $zipped_name[$#zipped_name];
      tr/[a-zA-Z][\.]//d; 
      $last_name = $_;

      $vol_title .= "\" $first_name to $last_name \"";
      print "volume label: $vol_title \n";

      $nssl = "\"NSSL, 1313 Halley, Norman, Ok, 73069, USA\"";

      print "Running mkisofs: \n"; 
      system ("nice -n 15 mkisofs -l -R -P $nssl -p $vol_title -o $image_name $my_dir");

      foreach $name_z (@zipped_name) {
        unlink $name_z; 
      }
      rmdir $my_dir; 
      chdir $dir;
}
#
# MAIN:
#
use File::stat;
use Getopt::Std;

getopts("hd:", \%option );

$usage =  "make_gz_cd.pl: Usage \n";
$usage .= " -h, print this message \n";
$usage .= " -d directory, run the make_gz_cd program on specified directory. \n";

if ( $option{h} ) {
  print $usage;
  exit();
}

#adjust file size to 650mb here if required
#$max_size = 695*1024*1024;
#$max_size = 100*1024*1024;
#now adjusted to 4.5 gigs and DVD's
$max_size = 3.5*1024*1024*1024;

$num = 0;
$sum = 0;

#
# check to see if a directory has been sent
#
if ( $option{d} ) {
  $dir = $option{d};
} else {
  print "Directory? ";
  $dir = <STDIN>;
  chop ($dir);
}

if( chdir $dir)
{
  @list=<*>;
  foreach $name (@list)
  {
    print "$name\n";
    $_ = $name;
    if ( m/gz/ ) {
    #do nothing if the file is already bziped
    }  else { 
    #bzip 2 the file with nice you can also cdrecord something else
     `nice -n 15 gzip $name`;
    }
  }

#
#Find the file size in the directory
# 
   @list=<*.gz>;
   $sum = 0; 
   $num = 0;
   foreach $name (@list) {
     print "new name: $name \n";
  
     $sb = stat($name);

     $sum +=$sb->size;
     $space = $max_size - $sum;
     print "Space left on DVD: $space \n";

     if ( $sum < $max_size ) {
       push @zipped_name, $name;
     } else {
       if ( $#zipped_name <= 1 ) {
         print "This file is too damn big at $sum \n";
         print "I will skip this file\n"
       } else {
         mk_image( @zipped_name);
       }
       @zipped_name = "";
       $sum = 0;
       push @zipped_name, $name;
     }  
   }
   
   mk_image ( @zipped_name );

}
